using System;

namespace Association
{
	public class MembreInconnu : System.Exception
	{
	}

	public class MembreDejaInscrit : System.Exception
	{
	}

	/// <summary>
	/// Description rsume de CAssociation.
	/// </summary>
	public class CAssociation
	{
		System.Collections.Hashtable m_hMembres =
			new System.Collections.Hashtable();
		CCaisse	m_Caisse = new CCaisse();
		CMembre m_President = null;
		CMembre m_Tresorier = null;

		public CAssociation()
		{
		}

		public CMembre Inscription(string nom, Decimal droits)
		{
			CMembre m = (CMembre) m_hMembres[nom];
			if (m != null)
				throw new MembreDejaInscrit();
			m_Caisse.Credite(droits);
			m = new CMembre(nom, droits);
			m_hMembres.Add(nom, m);
			return m;
		}

		public void Election(string nom_president, string nom_tresorier)
		{
			CMembre president = (CMembre) m_hMembres[nom_president];
			if (president == null)
				throw new MembreInconnu();
			if (m_President != president)
			{
				// Vire l'ancien prsident :
				if (m_President != null)
					m_President.Role = CMembre.MembreRole.Membre;
				president.Role = CMembre.MembreRole.President;
				m_President = president;
			}
			CMembre tresorier = (CMembre) m_hMembres[nom_tresorier];
			if (tresorier == null)
				throw new MembreInconnu();
			if (m_Tresorier != tresorier)
			{
				// Vire l'ancien trsorier :
				if (m_Tresorier != null)
					m_Tresorier.Role = CMembre.MembreRole.Membre;
				tresorier.Role = CMembre.MembreRole.Tresorier;
				m_Tresorier = tresorier;
			}
		}

		public void RecupereMembresActifs(out System.Collections.ArrayList liste)
		{
			liste = new System.Collections.ArrayList();
			foreach (CMembre m in m_hMembres.Values)
			{
				if (m.Actif)
					liste.Add(m);
			}
		}
	}
}
