using System;

namespace Association
{
	public class MontantNegatif : System.Exception
	{
	}

	public class PasAssezDeSous : System.Exception
	{
	}

	/// <summary>
	/// Description rsume de CCaisse.
	/// </summary>
	public class CCaisse
	{
		private Decimal	m_Solde = 0m;

		public CCaisse()
		{
		}

		public Decimal Solde
		{
			get
			{
				return m_Solde;
			}
		}

		public void Credite(Decimal montant)
		{
			if (montant < 0m)
				throw new MontantNegatif();
			m_Solde += montant;
		}

		public void Debite(Decimal montant)
		{
			if (montant < 0m)
				throw new MontantNegatif();
			if (montant > m_Solde)
				throw new PasAssezDeSous();
			m_Solde -= montant;
		}
	}
}
